/*
 * Created on 28 avr. 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package mc.formgenerator.bonita;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

import org.apache.xerces.dom.DOMImplementationImpl;
import org.w3c.dom.DOMImplementation;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;


/**
 * @author delfourr
 *
 */
public class DocumentParser {

	
	
	/**
	 * Default class constructor.
	 */
	public DocumentParser() {
		
	}




	
	/**
	 * Set the attributes of th DataProcess structure with the Document information.
	 * @param doc Document which owns the process information.
	 * @param dataProcess Structure which has to be set.
	 */
	private void parseProcess(Document doc, DataProcess dataProcess) {
		
		//new information will be saved in these variables
		String newName;
				
		HashMap newTable = new HashMap();
		
		
		//Root is the first tag of the document. Its name is "project"
		Element root = doc.getDocumentElement();



		//**************************************************************************
		//				GET THE PROCESS NAME FROM THE DOCUMENT
		//**************************************************************************


		//Save the process name
		NodeList elementName = root.getElementsByTagName("name");
	
		if (elementName.getLength() == 0) {
				System.out.println("There is no tag : name!");
			
				//default process name
				newName = "defaultProject"; 
		} 
		else {					
				Text nameProcess = (Text)elementName.item(0).getFirstChild();

				newName = nameProcess.getNodeValue();		
		}
		
		
		
		//**************************************************************************
		//				GET THE PROCESS PROPERTIES FROM THE DOCUMENT
		//**************************************************************************		
		
		

		//List of nodes named properties
		NodeList elementProperty = root.getElementsByTagName("properties");
		if (elementProperty.getLength() == 0) {
			System.out.println("There is no tag : properties!"); 
		} 
		else {	
				
				//Is unique, it's the first 
				Element propertyElement = (Element)elementProperty.item(0);
		
				//List of child nodes of element "properties" : the key-value  
				//NodeList elementsKeyValue = propertyElement.getElementsByTagName("*");
				NodeList elementsProperty = propertyElement.getElementsByTagName("property");
				int size = elementsProperty.getLength();

				//Save name-value if they exist
				if (size > 0) {

						for (int i=0; i<size; i++)
						{
							// new xml Format
							Element propertyElementNameValue = (Element)elementsProperty.item(i);
							
							NodeList elementsPropertyNameValue = propertyElementNameValue.getElementsByTagName("*");
							//Element propertyElementValue = (Element)elementsPropertyNameValue.item(0);							
							Text valueElement = (Text)elementsPropertyNameValue.item(0).getFirstChild(); 
							String currentKey = valueElement.getNodeValue();
							String currentValue = "";
							if ((Text)elementsPropertyNameValue.item(1).getFirstChild() != null)
							{
							   valueElement = (Text)elementsPropertyNameValue.item(1).getFirstChild(); 
							   currentValue = valueElement.getNodeValue();
						        }
								//old cml format
								//current node which gives the value
								//Text valueElement = (Text)elementsKeyValue.item(i).getFirstChild(); 
								
								//Takes the current node information
								//String currentValue = valueElement.getNodeValue();
								//String currentKey = elementsKeyValue.item(i).getNodeName();	
								
								
													
														
								//Puts them in the HashMap
								newTable.put(currentKey, currentValue);
						}
				
				}
		}
				
		//**************************************************************************
		//				SET DATAPROCESS ATTRIBUTES 
		//**************************************************************************	
		
		dataProcess.setProcessName(newName);
		dataProcess.setProcessProperties(newTable);

	}




	/**
	 * Say if the document has properties about the process.
	 * @param doc Document which owns the process information.
	 * @return boolean
	 */
	public boolean hasProperties(Document doc) {

		//Root is the first tag of the document. Its name is "project"
		Element root = doc.getDocumentElement();
		
		//List of nodes named properties
		NodeList elementProperty = root.getElementsByTagName("properties");
		
		Element propertyElement = (Element)elementProperty.item(0);
				
		return (propertyElement.getElementsByTagName("*").getLength() != 0);
		
	}






	/**
	 * Creates a DataProject structure thanks to the Document information.
	 * @param doc Document which represents the project.
	 * @return dataProject Structure which represents the project.
	 */
	public DataProject parseProject(Document doc) {
		
		//the structure to return
		DataProject dataProject = new DataProject();
		
		//parse document to obtain the name and the properties of the activity
		this.parseProcess(doc, dataProject);
		
		return dataProject;
	}







	/**
	 * Creates a DataActivity structure thanks to the Document information.
	 * @param doc Document which represents the activity.
	 * @return dataProject Structure which represents the activity.
	 */
	public DataActivity parseActivity(Document doc) {
		
		//the structure to return
		DataActivity dataActivity = new DataActivity();
		
		//parse document to obtain the name and the properties of the activity
		this.parseProcess(doc, dataActivity);
		
		String projectName ="";
		
		
		//**************************************************************************
		//				GET THE PROJECT NAME FROM THE DOCUMENT
		//**************************************************************************
		
		//Root is the first tag of the document. Its name is "project"
		Element root = doc.getDocumentElement();
			
		//Save the process name
		NodeList elementName = root.getElementsByTagName("nameProject");

		if (elementName.getLength() == 0) {
				System.out.println("There is no tag : nameProject!");
				
				//default project name
				projectName = "defaultProject"; 
		} 
		else {					
				Text nameProcess = (Text)elementName.item(0).getFirstChild();
				projectName = nameProcess.getNodeValue();		
		}
		
		
		//**************************************************************************
		//		SET THE PROJECTNAME ATTRIBUTE AND RETURNS DATAACTIVITY INSTANCE 
		//**************************************************************************	
		
		dataActivity.setProjectName(projectName);
				
		return dataActivity;
	}





	
	/**
	 * Creation of a xml document by using Xerces
	 * @param data The data to put in the Document.
	 * @return Document contains process information given by the DataProcess.
	 */
	public Document createDocument(DataProcess data){
	  	
	   //Out Document for manipulation by Xerces API
	   Document document = null;
	  	
	   //Set for all the hmap keys
	   Set keySet = null;
	  	
	   //Interface
	   DOMImplementation domImpl = new DOMImplementationImpl();
		
	   //Document creation with the root element called project
	   document = domImpl.createDocument(null, "process" , null);
		
	   //Setting the root element always called "project"
	   Element root = document.getDocumentElement();
		
		
	   //Name of the Bonita project***************************************
	   Element elementName = document.createElement("name");
		
	   //Value of the node called "name"
	   Text textName = document.createTextNode(data.getProcessName()); 
	   elementName.appendChild(textName);
	   root.appendChild(elementName);
	   //*****************************************************************
		
			
	
	   //Node "properties" that will contain project properties************
	   Element elementProperties = document.createElement("properties");
	   //******************************************************************
		
		
	   //Getting keys set
	   keySet = data.getProcessProperties().keySet();
		
	   //Current key
	   String currentKey = "";
		
	   //Current value
	   String currentValue = "";
		
	   //For each key we must get the value associeted
	   Iterator it = keySet.iterator();
	   while(it.hasNext())
	   {
                                //New format : <properties><property><name>key</name><value>value></value></properties>
				Element elementProperty = document.createElement("property");

				//Getting the key
				currentKey = (String)it.next();

				//Getting the value
				currentValue = 	(String)data.getProcessProperties().get(currentKey);
					
				//old format : <properties><key>value</key><key>value</key></properties>
				//Element elementKey = document.createElement(currentKey);
				//Text textKey = document.createTextNode(currentValue); 
				
				Element elementPropertyName = document.createElement("name");
				Text textPropertyName = document.createTextNode(currentKey);
				elementPropertyName.appendChild(textPropertyName);
				
				Element elementPropertyValue = document.createElement("value");
				Text textPropertyValue = document.createTextNode(currentValue); 
				elementPropertyValue.appendChild(textPropertyValue);

				//Adding this element to the "property" element
				elementProperty.appendChild(elementPropertyName);
				elementProperty.appendChild(elementPropertyValue);	
									
				//Adding this element to the "properties" element
				elementProperties.appendChild(elementProperty);	
	   	}
		
		//Adding the node to the root element
		root.appendChild(elementProperties);
			
		//Return the document
		return document;
	}
	
	
	
	


	/**
	 * Creation of a xml document by using Xerces
	 * @param data The data to put in the Document.
	 * @return Document contains activity information given by the DataActivity.
	 */
	public Document createDocument(DataActivity data){
	  	
	   	//Out Document for manipulation by Xerces API
	   	Document document = null;
	  	  	
	  	document = this.createDocument((DataProcess)data);
		
		//Getting the root element	
	  	Element root = document.getDocumentElement();
	  	
	  	//Element creation
		Element elementNameProject = document.createElement("nameProject");
		
		//Value of the node called "nameProject"
		Text textNameProject = document.createTextNode(data.getProjectName()); 
		
		//Adding the text to the element
		elementNameProject.appendChild(textNameProject);
		
		//Adding the node to the root element
		root.appendChild(elementNameProject);	
	  		
		//Return the document
		return document;
	}
}
