package hero.util;

/**
*
* Bonita
* Copyright (C) 1999 Bull S.A.
* Bull 68 route de versailles  78434 Louveciennes Cedex France
* Further information: bonita@objectweb.org
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*
*
--------------------------------------------------------------------------
* $Id: BonitaConfig.java,v 1.2 2004/11/29 12:29:48 mvaldes Exp $
*
--------------------------------------------------------------------------
*/

import java.util.List;

import javax.management.MBeanServer;
import javax.management.MBeanServerFactory;
import javax.management.ObjectName;

public class BonitaConfig {
	
	private ObjectName config;
	private MBeanServer server;	
	private static BonitaConfig bc = null; // Singleton pattern

	public BonitaConfig() throws HeroException{
		try{
			config = new ObjectName("jonas:type=service,name=BonitaConfigService");
			List list = MBeanServerFactory.findMBeanServer(null);
			server = (MBeanServer) list.iterator().next();			
		} catch (Exception e) {e.printStackTrace();
			throw new HeroException(e.getMessage());
		}		
	}
	
	public static BonitaConfig getInstance() throws HeroException{
		if ( bc == null) {
			bc = new BonitaConfig();
		}
		return bc;
	}
		
	public boolean getProcessJMS(String projectName) throws HeroException
	{
		try {
			Boolean value =(Boolean) server.invoke(config, "getProcessJMS", new Object[] { projectName},
					new String[] {"".getClass().getName()});
			return value.booleanValue();
		} catch (Exception e) {
			throw new HeroException(e.getMessage());
		}
	}
	
	public boolean getProcessLog(String projectName) throws HeroException
	{
		try {
			Boolean value =(Boolean) server.invoke(config, "getProcessLog", new Object[] { projectName},
					new String[] {"".getClass().getName()});
			return value.booleanValue();
		} catch (Exception e) {
			throw new HeroException(e.getMessage());
		}
	}	
	
	public boolean getProcessTrace(String projectName) throws HeroException
	{
		try {
			Boolean value =(Boolean) server.invoke(config, "getProcessTrace", new Object[] { projectName},
					new String[] {"".getClass().getName()});
			return value.booleanValue();
		} catch (Exception e) {
			throw new HeroException(e.getMessage());
		}
	}
	
	public String getPocessLogLevel(String projectName) throws HeroException
	{
		try {
			String value =(String) server.invoke(config, "getProcessLogLevel", new Object[] { projectName},
					new String[] {"".getClass().getName()});
			return value;
		} catch (Exception e) {
			throw new HeroException(e.getMessage());
		}
	}	
	
	public String getPocessTraceLevel(String projectName) throws HeroException
	{
		try {
			String value =(String) server.invoke(config, "getProcessTraceLevel", new Object[] { projectName},
					new String[] {"".getClass().getName()});
			return value;
		} catch (Exception e) {
			throw new HeroException(e.getMessage());
		}
	}
	
	public String getPocessHistoric(String projectName) throws HeroException
	{
		try {
			String value =(String) server.invoke(config, "getProcessHistoric", new Object[] { projectName},
					new String[] {"".getClass().getName()});
			return value;
		} catch (Exception e) {
			throw new HeroException(e.getMessage());
		}
	}
	
	public void updateJMS(boolean jms) throws HeroException
	{
		try {
			server.invoke(config, "updateJMS", new Object[] {new Boolean(jms)},new String[] {"boolean"});
		} catch (Exception e) {
			throw new HeroException(e.getMessage());
		}
	}
	
}